function C_ErrorMsg takes string s returns nothing
    printf(RED + "Error: " + s + "|r")
endfunction

function C_SetComputers takes nothing returns nothing
    int i = 0
    while (i < 15)
    {
        if (GetPlayerController(Player(i)) == MAP_CONTROL_COMPUTER)
        {
            SetPlayerName(Player(i), "Computer")
            SetPlayerOnScoreScreen(Player(i), false)
        }
        i++
    } 
endfunction

function C_ResizeTable takes leaderboard l returns nothing
    int size = LeaderboardGetItemCount(l)
    if (LeaderboardGetLabelText(l) == "")
    {
        size--
    }
    LeaderboardSetSizeByItemCount(l, size)
endfunction

function C_RemoveTableRow takes leaderboard l, int row returns nothing
    LeaderboardRemoveItem(l, row)
    C_ResizeTable(l)
endfunction

function C_AddTableRow takes leaderboard l, string label, int value, bool flag returns nothing
    int i = 0
    bool complete = false
    while (i < 15)
    {
        if (!LeaderboardHasPlayerItem(l, Player(i)))
        {
            LeaderboardAddItem(l, label, value, Player(i))
            if (label == "" && value == 0)
            {
                LeaderboardSetItemStyle(l, i, false, false, false)
            }
            elseif (value == 0 && !flag)
            {
                LeaderboardSetItemStyle(l, i, true, false, false)
            }
            complete = true
        }
        if (complete)
        {
            C_ResizeTable(l)
            break
        }
        i++
    }
    if (!complete)
    {
        C_ErrorMsg("unable to add a new row. No space.")
    }
endfunction

function C_StartCount takes nothing returns nothing
    0:time++
    if (0:time > 59)
    {
        0:time = 0
        1:time++
        if (1:time > 59)
        {
            1:time = 0
            2:time++
            if (2:time > 24)
            {
                0:time = 0 //Seconds
                1:time = 0 //Minutes
                2:time = 0 //Hours
            }
        }
    }
endfunction

function C_StartInitTimer takes nothing returns nothing
    timer t = new timer
    TimerStart(t, 1., true, function C_StartCount)
endfunction

function C_CreateTable takes string label, bool IsVisible returns leaderboard
    leaderboard l = new leaderboard
    int i = 0
    while(i < 15)
    {
        PlayerSetLeaderboard(Player(i), l)
        i++
    }
    LeaderboardSetLabel(l, label)
    LeaderboardDisplay(l, IsVisible)
    return l
endfunction

function C_AddGoldToPlayer takes int value, player p returns nothing
    SetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD, GetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD) + value)
endfunction

function C_RemoveGoldFromPlayer takes int value, player p returns nothing
    SetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD, GetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD) - value)
endfunction

function C_AddLumberToPlayer takes int value, player p returns nothing
    SetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER, GetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER) + value)
endfunction

function C_RemoveLumberFromPlayer takes int value, player p returns nothing
    SetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER, GetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER) - value)
endfunction

function C_RectToLoc takes rect r returns location
    location l = Location(GetRectCenterX(r), GetRectCenterY(r))
    return l
endfunction

function C_UnitHasItemOfType takes unit u, int itemId returns bool
    int i = 0
    item indexItem
    while (i < 6)
    {
        indexItem = UnitItemInSlot(u,i)
        if (indexItem != null && GetItemTypeId(indexItem) == itemId) then
            return true
        endif
        i++
    }
    return false
endfunction

function C_IsUnitInRect takes unit u, rect r returns bool
    float x = GetUnitX(u)
    float y = GetUnitY(u)
    if (GetRectMinX(r)-32 <= x) and (x <= GetRectMaxX(r)+32) and (GetRectMinY(r)-32 <= y) and (y <= GetRectMaxY(r)+32) then
        return true
    endif
    return false
endfunction

function C_IsUnitCollapse takes unit u, real radius returns bool
    float x = GetUnitX(u)
    float y = GetUnitY(u)
    group g = new group
    bj_groupCountUnits = 0
    GroupEnumUnitsInRange(g, x, y, radius, null)
    ForGroup(g, function CountUnitsInGroupEnum)
    int count = bj_groupCountUnits
    DestroyGroup(g)
    if (count == 1) then
        return false
    endif
    return true
endfunction

function  CountUnitsInGroupEnumWithNoAllies takes nothing returns bool
    unit u = GetFilterUnit()
    if (!IsPlayerAlly(GetOwningPlayer(u), C_IsUnitCollapseWithEnemiesPlayer) && GetUnitState(u, UNIT_STATE_LIFE) > 0) then
        return true
    endif
    return false
endfunction

function CountUnitsInGroupEnumWithAllies takes nothing returns bool
    unit u = GetFilterUnit()
    if (GetOwningPlayer(u) == C_IsUnitCollapseWithEnemiesPlayer || IsPlayerAlly(GetOwningPlayer(u), C_IsUnitCollapseWithEnemiesPlayer)) then
        if (GetUnitState(u, UNIT_STATE_LIFE) > 0) then
            return true
        endif
    endif
    return false
endfunction

function C_IsUnitCollapseWithEnemies takes unit u, real radius returns bool
    float x = GetUnitX(u)
    float y = GetUnitY(u)
    group g = new group
    bj_groupCountUnits = 0
    C_IsUnitCollapseWithEnemiesPlayer = GetOwningPlayer(u)
    GroupEnumUnitsInRange(g, x, y, radius, Condition(function CountUnitsInGroupEnumWithNoAllies))
    ForGroup(g, function CountUnitsInGroupEnum)
    int count = bj_groupCountUnits
    DestroyGroup(g)
    if (count == 0) then
        return false
    endif
    return true
endfunction